{$A+} {Word allign}
{$F-} {Use NEAR calls}
{$G-} {8086 instructions}
{$D-} {Strip debug information}
{$B-} {Short boolean evaluation}
{$L-} {Do not generate local symbols information}
{$M, 1024,0,0}


PROGRAM Friday13th_INTRO_1;


CONST
  Copyright : STRING[27] = 'cTgfwn|0y'#26'\Ǝ';
                          {'Code & Gfx by The GodFather';}
  NoFPoints = 400;


{$I INTROS\F13_STAR\LOGO13_1.PAS}
{$I INTROS\F13_STAR\PICT13_1.PAS}
{$I INTROS\F13_STAR\INTRO13.INC}


TYPE
  TPicture = ARRAY[1..PictureX*PictureY] OF Byte;


VAR
   Pict: TPicture;
   Stars: TPoints;




{---------------------------------------------------------------------------}
PROCEDURE InitSTARS;
VAR Index:Integer;
BEGIN
  Randomize;
  FOR Index := 1 TO NofPoints DO
  BEGIN
    Stars[Index].X := Random(Max_X);
    Stars[Index].Y := Random(Max_Y-20);
    Stars[Index].OnScreen := False;
  END;
END;






{---------------------------------------------------------------------------}
PROCEDURE MoveStars;
VAR
  Index    : Integer;
  TempX    : Integer;
  TempY    : Integer;
  TempColor: Integer;
  StarState: Byte;
  OnScreen : Boolean;


  FUNCTION OK:Boolean;
  VAR
    hardX,hardY: Byte;
    softX,softY: Byte;
    Symbol,Curr: Byte;
    Off        : Integer;
    O_K        : Boolean;

  BEGIN
    OK := True;
    hardX := TempX DIV FontX;
    hardY := TempY DIV FontY;
    softX := TempX MOD FontX;
    softY := TempY MOD FontY;
    Off := hardY*80+hardX+1;
    Symbol := Ord(Logo[Off].Ch);
    Curr := Font8x14^[Symbol,SoftY+1];
    O_K := (Curr AND BitMasc[SoftX]) <> BitMasc[SoftX];

    IF (TempX > 460) AND (TempX < 582) AND
       (TempY > 130) AND (TempY < 265)
         THEN BEGIN
                softX := TempX - 460;
                softY := TempY - 130;
                O_K := (Pict[Pred(softX) * PictureY + softY]) = 0;
              END;

    OK := O_K;
  END;


BEGIN
  REPEAT
    VRetrace;
    StarState := 0;
    FOR Index := 1 TO NofPoints DO
    BEGIN
      Inc(StarState);
      TempX := Stars[Index].X;
      TempY := Stars[Index].Y;
      OnScreen := Stars[Index].OnScreen;
      IF OnScreen THEN PutPixel(TempX,TempY,0);

      Dec(TempX,StarState);
      TempColor := 7;
      IF StarState = 3 THEN TempColor := 15;

      IF TempX < 0 THEN TempX := Max_X;
      Stars[Index].X := TempX;
      OnScreen := OK;
      Stars[Index].OnScreen := OnScreen;

      IF OnScreen THEN PutPixel(TempX,TempY,TempColor);
      IF StarState = 3 THEN StarState := 0;
    END;
  UNTIL KeyPressed;
END;
{---------------------------------------------------------------------------}







{---------------------------------------------------------------------------}
PROCEDURE DeCompressPicture;
VAR BufIndex,PictIndex:Word;
    Color,Counter:Byte;
BEGIN
  BufIndex := 0;
  PictIndex := 1;
  REPEAT
    Inc(BufIndex);
    Counter := Picture[BufIndex];
    IF Counter >= 240
      THEN BEGIN
             Color := Counter - 240;
             Pict[PictIndex] := Color;
             Inc(PictIndex);
           END
      ELSE BEGIN
             Inc(BufIndex);
             Color := Picture[BufIndex];
             FillChar(Pict[PictIndex],Counter,Color);
             Inc(PictIndex,Counter);
           END;
  UNTIL PictIndex >= SizeOf(Pict);
END;


PROCEDURE ShowPicture;
VAR I,R:Integer; Col:Byte;
BEGIN
  FOR R := PictureY DOWNTO 1 DO
    FOR I := PictureX DOWNTO 1 DO
    BEGIN
      Col := Pict[Pred(I) * PictureY + R];
      IF Col <> 0 THEN PutPixel(I+PictX,R+PictY,Col);
    END;
END;
{---------------------------------------------------------------------------}






{------------------------------ MAIN PROGRAM -------------------------------}
BEGIN
  InitSTARS;
  DeCompressPicture;

  Font8x14 := GetFontAddress;

  FadeDownPal;
  VideoMode($10);
  ShowLOGO;
  ShowPICTURE;
  MoveSTARS;
  VideoMode($03);

  { Show logo }
  ASM
    MOV AX, 0B800h
    MOV ES, AX
    XOR DI, DI
    MOV SI, OFFSET Logo
    MOV CX, 4000 / 2
    REP MOVSW
    MOV AX, 040h
    MOV ES, AX
    MOV AL, 25
    MOV ES:[$50], AL  { Cursor X }
    MOV AL, 23
    MOV ES:[$51], AL  { Cursor Y }
  END;

  { Decode copyright msg }
  RandSeed := Length(Copyright) + 48;
  FOR Index := 1 TO Length(Copyright) DO
    Copyright[Index] := Chr(Byte(Copyright[Index]) XOR Random(255) XOR $7A);

  { Show copyright msg }
  ASM
   MOV SI, OFFSET Copyright
   XOR CX, CX
   MOV CL, DS:[SI]
   INC SI
 @Loop:
   LODSB
   MOV AH, 2
   MOV DL, AL
   INT 21h
   LOOP @Loop
  END;
  { End of program }
END.